#include <GUIConstants.au3>
#include <File.au3>
#include <GuiListView.au3>

$tabsOn = 1
$k = 0
$unLoaded = 1

$scriptFolder = "scripts\"
$GUItitle = "codeHelper"
$GUIsize = 550
$nodeSize = $GUIsize - 550
$indentX = 32
$indentY = $indentX + 30

GUICreate($GUItitle, $GUIsize, $GUIsize)
$tab = GUICtrlCreateTab(10, 10, $GUIsize - 20, $GUIsize - 20)

GUISetState(@SW_SHOW)

;Actions Tab
$actionsTab = GUICtrlCreateTabItem("Actions")
;top (Load Code) group
GUICtrlCreateGroup("", -99, -99, 1, 1)
$loadCodeGroup = GUICtrlCreateGroup("Load Code", $indentX, $indentY, 481, 185)
$scriptsList = GUICtrlCreateListView("Path                 |Comments|HTML|CSS|JS|PHP|XML|XLS", $indentX + 20, $indentY + 20, 385, 149)
$FileList = _FileListToArray($scriptFolder, "*", 1)
If @error = 1 Then
	MsgBox(0, "", "No files found in /scripts/ folder.")
EndIf
For $i = 1 To $FileList[0] ;.ini, .txt, .etc
	If StringInStr($FileList[$i], ".ini") Then ;if ini then
		$sectNames = IniReadSectionNames($scriptFolder & $FileList[$i]) ;read section names
		$type = ""
		$typeHTML = 0
		$typeCSS = 0
		$typeJS = 0
		$typePHP = 0
		$typeXML = 0
		$typeXSL = 0
		For $j = 1 To UBound($sectNames) - 1 ;for all sections...
			$fileNameLoc = ""
			$fileNameLoc = IniRead($scriptFolder & $FileList[$i], $sectNames[$j], "filenameloc", "") ;read value of filenameloc
			$comment = IniRead($scriptFolder & $FileList[$i], "comments", "comment", "") ;read value of comment
			If Not $fileNameLoc = "" Then
				If StringInStr($fileNameLoc, ".html") Then $typeHTML = $typeHTML + 1
				If StringInStr($fileNameLoc, ".css") Then $typeCSS = $typeCSS + 1
				If StringInStr($fileNameLoc, ".js") Then $typeJS = $typeJS + 1
				If StringInStr($fileNameLoc, ".php") Then $typePHP = $typePHP + 1
				If StringInStr($fileNameLoc, ".xml") Then $typeXML = $typeXML + 1
				If StringInStr($fileNameLoc, ".xsl") Then $typeXSL = $typeXSL + 1
			EndIf
		Next
		$FileItem = StringReplace($FileList[$i], ".ini", "")
		If $i = 1 Then Dim $scriptItem[1000]
		$scriptItem[$i] = GUICtrlCreateListViewItem($FileItem & "|" & $comment & "|" & $typeHTML & "|" & $typeCSS & "|" & $typeJS & "|" & $typePHP & "|" & $typeXML & "|" & $typeXSL, $scriptsList)
	EndIf
Next
$unLoadButton = GUICtrlCreateButton("UNLOAD", $indentX + 415, $indentY + 120, 57, 25, 0)
$loadButton = GUICtrlCreateButton("LOAD", $indentX + 415, $indentY + 150, 57, 25, 0)
GUICtrlCreateTabItem(""); end tabitem definition

GUISetState()

; Run the GUI until the dialog is closed
While 1
	$msg = GUIGetMsg()
	If $msg = $GUI_EVENT_CLOSE Then ExitLoop
	If $msg = $loadButton Then
		If $unLoaded = 1 Then
			$listItemString = GUICtrlRead(GUICtrlRead($scriptsList))
			$fileNameLoc = StringSplit($listItemString, "|")
			$tabFileName = $fileNameLoc[1]
			$filename = $scriptFolder & $fileNameLoc[1] & ".ini"
			$content = ""
			$section = IniReadSectionNames($filename)
			For $i = 1 To UBound($section) - 1 ;for every section...
				$tabName = IniRead($filename, $section[$i], "tabname", "null") ;get the listed tab name
				$fileNameLoc = IniRead($filename, $section[$i], "filenameloc", "null") ;get the listed file name
				If $fileNameLoc = "null" Then
					;do nothing
				ElseIf $tabsOn = 1 Then
					$file = FileOpen($fileNameLoc, 0) ;open that file
					If $file = -1 Then
						MsgBox(0, "Error", "Unable to open file " & $fileNameLoc)
					Else
						$content = FileRead($file) ;read the files contents
						If $i = 1 Then
							Dim $Tab_Item[50]
							Dim $Edit_Item[50]
						EndIf
						$k = $k + 1
						$Tab_Item[$i] = GUICtrlCreateTabItem($tabName) ;create the tab with appropriate tab name
						;MsgBox(0,"***",$Tab_Item[$i])
						$Edit_Item[$i] = GUICtrlCreateEdit($content, $indentX, $indentY, $GUIsize - 65, $GUIsize - 90) ;create the edit area with appropriate contents
					EndIf
					FileClose($file)
					GUICtrlSetState($Tab_Item[$i], $GUI_SHOW)
					$unLoaded = 0
				#cs
				ElseIf $tabsOn = 0 Then
					$file = FileOpen($fileNameLoc, 0) ;open that file
					If $file = -1 Then
						MsgBox(0, "Error", "Unable to open file " & $fileNameLoc)
					Else
						$content = $content & FileRead($file) & @CRLF ;read and return the files contents
					EndIf
					FileClose($file)
					$unLoaded = 0
				#ce
				Else
					MsgBox(0, "Alert", "There was an error creating a tab")
				EndIf
			Next
		ElseIf $unLoaded = 0 Then
			MsgBox(0, "Alert", "You must unload current file to load another")
		EndIf
		#cs
		If $tabsOn = 0 Then
			$tab = GUICtrlCreateTabItem($tabFileName) ;create the tab with appropriate tab name
			$edit = GUICtrlCreateEdit($content, $indentX, $indentY, $GUIsize - 65, $GUIsize - 90) ;create the edit area with appropriate contents
		EndIf
		#ce
	EndIf
	If $msg = $unLoadButton Then
		If $unLoaded = 0 Then
			For $i = 1 To $k
				GUICtrlDelete($Tab_Item[$i])
				$unLoaded = 1
			Next
		EndIf
	EndIf
WEnd